## pwntools 4.9.0

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build
DASHBUILD     = ./dashbuild.py
TAR           = tar

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source


.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext dash

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  dash       to make a Dash docset"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*
	-rm -rf /tmp/user/pwn*
	-rm -rf $(HOME)/.cache/.pwntools-cache
	-rm -rf /tmp/pwn* 2>/dev/null || true
	-rm -rf build

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/pwntools.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/pwntools.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/pwntools"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/pwntools"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

dash:
	$(DASHBUILD) source $(BUILDDIR)/dash
	$(TAR) --exclude='.DS_Store' -cvzf $(BUILDDIR)/dash/pwntools.tgz -C $(BUILDDIR)/dash pwntools.docset
	@echo "Build finished. The Dash docset is in $(BUILDDIR)/dash."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== docs/requirements.txt ===
capstone
coveralls
doc2dash
docutils<0.18
isort
mako>=1.0.0
paramiko>=1.15.2
pip>=6.0.8
pyelftools>=0.2.3
pygments>=2.0
pypandoc
pyserial>=2.7
requests>=2.5.1
ropgadget>=5.3
sphinx==1.8.6; python_version<'3'
sphinx>=4.5.0; python_version>='3'
sphinx_rtd_theme
sphinxcontrib-autoprogram<=0.1.5

=== extra/docker/Makefile ===
subdirs=$(shell find . -type d -depth 1 | xargs basename)
tags=base stable beta dev
ROOT=$(shell git rev-parse --show-toplevel)
CMD ?= zsh

ifneq ($(HISTFILE),)
MOUNT_HISTFILE=--mount type=bind,source="$(HISTFILE)",target=/home/pwntools/.history
endif

all: $(subdirs) $(tags)

tags: $(tags)

$(subdirs)::
	@echo "Building $@"
	docker build -t pwntools/pwntools:$(shell basename $(@)) "$@"

develop::
	docker run -it \
		--privileged \
		--net=host \
		--hostname localhost \
		--ulimit core=-1:-1 \
		$(MOUNT_HISTFILE) \
		--mount type=bind,source="$(ROOT)",target=/home/pwntools/pwntools \
		pwntools/pwntools:$(shell basename $(@)) \
		$(CMD)

debug:
	@echo "Subdirs   $(subdirs)"
	@echo "Tags      $(tags)"

clean:
	docker container prune
	docker

FORCE:

.PHONY: all $(subdirs) $(makefiles) $(tags)

=== travis/docker/Makefile ===
ROOT = $(shell git rev-parse --show-toplevel)
$(shell reset)

Dockerfile: FORCE
	cp $(ROOT)/extra/docker/develop/Dockerfile Dockerfile
	cat Dockerfile.travis >> Dockerfile

all: doctest3

shell bash: image
	@echo Running interactive shell
	docker run -it --privileged --net=host --hostname localhost \
		--ulimit core=-1:-1 \
		--mount type=bind,source="$(ROOT)",target=/home/pwntools/pwntools \
		--entrypoint ./tmux.sh \
		travis

doctest2 doctest3: image FORCE
	@echo Running doctests
	docker run -it --privileged --net=host --hostname localhost \
		--ulimit core=-1:-1 \
		--mount type=bind,source="$(ROOT)",target=/home/pwntools/pwntools \
		--env TARGET=$(TARGET) \
		--entrypoint ./$@ \
		travis

image: Dockerfile
	docker build -t travis .

FORCE:
.PHONY: all image doctest bash

=== pwnlib/data/syscalls/Makefile ===
ROOT=$(shell git rev-parse --show-toplevel)
TEMPLATE_DIR="$ROOT/pwnlib/shellcraft/templates/common/linux/syscalls"

all: generate.py functions.py
	python generate.py "$(ROOT)/pwnlib/shellcraft/templates/common/linux/syscalls"

functions.py:
	wget https://raw.githubusercontent.com/zachriggle/functions/master/functions.py

.phony: all

=== debian/changelog ===
pwntools (4.9.0-1) unstable; urgency=medium

  * Use mode=git for d/watch
  * New upstream version 4.9.0
  * Refresh patches
    - Drop 0004-Use-sphinx.ext.napoleon-instead-of-sphinxcontrib.nap.patch
      (fixed upstream)
    - Drop 0007-Workaround-for-RWX-segment-warnings-in-GNU-ld.patch
      (fixed upstream)

 -- Timo Röhling <roehling@debian.org>  Mon, 02 Jan 2023 21:16:46 +0100

pwntools (4.9.0~beta0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set field Upstream-Name in debian/copyright.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 14 Oct 2022 12:28:22 +0100

pwntools (4.9.0~beta0-1) unstable; urgency=medium

  * Fix d/watch
  * New upstream version 4.9.0~beta0
    - Fix ELF.libc_start_main_return with glibc 2.34+
  * Workaround for RWX segment warnings in GNU ld
  * Update Recommends and Suggests

 -- Timo Röhling <roehling@debian.org>  Thu, 29 Sep 2022 21:25:57 +0200

pwntools (4.8.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.6.1
  * Make sphinx build date deterministic
  * Remove broken auto-generated autopkgtest
  * Add suggestions for useful tools
  * Fix d/clean
  * Add lintian overrides for test binaries

 -- Timo Röhling <roehling@debian.org>  Thu, 08 Sep 2022 13:02:40 +0200

pwntools (4.8.0-1) unstable; urgency=medium

  * New upstream version 4.8.0

 -- Timo Röhling <roehling@debian.org>  Wed, 27 Apr 2022 01:08:26 +0200

pwntools (4.7.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1002935)

 -- Timo Röhling <roehling@debian.org>  Mon, 11 Apr 2022 20:24:37 +0200

=== debian/control ===
Source: pwntools
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Section: python
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 dh-sequence-sphinxdoc <!nodoc>,
 pandoc,
 python3-all,
 python3-capstone,
 python3-colored-traceback,
 python3-dateutil,
 python3-intervaltree,
 python3-mako,
 python3-packaging,
 python3-paramiko,
 python3-pip,
 python3-psutil,
 python3-pyelftools,
 python3-pygments,
 python3-requests,
 python3-ropgadget,
 python3-rpyc,
 python3-serial,
 python3-setuptools,
 python3-socks,
 python3-sortedcontainers,
 python3-sphinx <!nodoc>,
 python3-sphinxcontrib.autoprogram <!nodoc>,
 python3-unicorn,
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/python-team/packages/pwntools.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/pwntools
Homepage: https://pwntools.com
Rules-Requires-Root: no
Description: CTF framework and exploit development library
 pwntools is designed for rapid prototyping and development, to make
 exploit writing as simple as possible. The primary use cases of this
 framework are CTF hacking contests, where vulnerabilities in a sandbox
 environment are exploited to gain access to a "flag" file or a secret
 string, as proof of successful infiltration.

Package: python3-pwntools
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 gdb,
 gdbserver,
Suggests:
 gdb-multiarch,
 qemu-user-static,
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: python-pwntools-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: ${source:Synopsis} (documentation)
 ${source:Extended-Description}
 .
 This package installs the API documentation for pwntools

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = pwntools
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
export PYBUILD_AFTER_INSTALL=$(CURDIR)/debian/rules run-sphinx PYTHONPATH=$(CURDIR)/debian/python3-$(PYBUILD_NAME){install_dir}
endif

%:
	dh $@ --buildsystem=pybuild

# Tests are written as doctests
override_dh_auto_test:

BUILD_DATE = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "@$(SOURCE_DATE_EPOCH)")
run-sphinx:
	$(MAKE) -C docs html SPHINXOPTS="-D today=\"$(BUILD_DATE)\""

## pwntools 4.10.0

=== debian/changelog ===
pwntools (4.10.0-1) unstable; urgency=medium

  * New upstream version 4.10.0
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Mon, 12 Jun 2023 13:38:14 +0200

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
  python3-sphinx <!nodoc>,
  python3-sphinxcontrib.autoprogram <!nodoc>,
  python3-unicorn,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/python-team/packages/pwntools.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pwntools
 Homepage: https://pwntools.com

## pwntools 4.12.0

=== docs/requirements.txt ===
--- 
+++ 
@@ -1,7 +1,9 @@
 capstone
-coveralls
+coverage[toml]
+python-dateutil
 doc2dash
 docutils<0.18
+intervaltree
 isort
 mako>=1.0.0
 paramiko>=1.15.2
@@ -10,6 +12,8 @@
 pygments>=2.0
 pypandoc
 pyserial>=2.7
+pysocks
+psutil
 requests>=2.5.1
 ropgadget>=5.3
 sphinx==1.8.6; python_version<'3'

=== travis/docker/Makefile ===
--- 
+++ 
@@ -4,6 +4,8 @@
 Dockerfile: FORCE
 	cp $(ROOT)/extra/docker/develop/Dockerfile Dockerfile
 	cat Dockerfile.travis >> Dockerfile
+	cp $(ROOT)/extra/docker/develop/10-import.py 10-import.py
+	cp $(ROOT)/extra/docker/develop/ipython_config.py ipython_config.py
 
 all: doctest3

=== debian/changelog ===
pwntools (4.12.0-1) unstable; urgency=medium

  * New upstream version 4.12.0
  * Refresh patches (no functional changes)
  * Improve documentation build in d/rules

 -- Timo Röhling <roehling@debian.org>  Fri, 23 Feb 2024 13:44:05 +0100

pwntools (4.11.1-1) unstable; urgency=medium

  * New upstream version 4.11.1
  * Refresh patches
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Wed, 15 Nov 2023 17:55:27 +0100

pwntools (4.11.0-1) unstable; urgency=medium

  * New upstream version 4.11.0
  * Switch to pybuild-plugin-pyproject

 -- Timo Röhling <roehling@debian.org>  Sat, 16 Sep 2023 11:25:25 +0200

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
  dh-sequence-python3,
  dh-sequence-sphinxdoc <!nodoc>,
  pandoc,
+ pybuild-plugin-pyproject,
  python3-all,
  python3-capstone,
  python3-colored-traceback,

## pwntools 4.13.1

=== debian/changelog ===
pwntools (4.13.1-1) unstable; urgency=medium

  * New upstream version 4.13.1
  * Refresh patch (no functional changes)
  * Wrap and sort Debian package files
  * Add missing depend on python3-six

 -- Timo Röhling <roehling@debian.org>  Tue, 01 Oct 2024 17:47:15 +0200

pwntools (4.13.0-1) unstable; urgency=medium

  * New upstream version 4.13.0
  * Update copyright
  * Refresh patches (no functional changes)
  * Bump Standards-Version to 4.7.0
  * Add build dependency on python3-sphinx-rtd-theme

 -- Timo Röhling <roehling@debian.org>  Sat, 17 Aug 2024 00:41:58 +0200

## pwntools 4.14.0

=== debian/changelog ===
pwntools (4.14.0-1) unstable; urgency=medium

  * New upstream version 4.14.0
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sat, 18 Jan 2025 23:00:04 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: pwntools
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
-Uploaders: Timo Röhling <roehling@debian.org>
+Uploaders:
+ Timo Röhling <roehling@debian.org>,
 Section: python
 Priority: optional
 Build-Depends:
@@ -27,12 +28,14 @@
  python3-rpyc,
  python3-serial,
  python3-setuptools,
+ python3-six,
  python3-socks,
  python3-sortedcontainers,
  python3-sphinx <!nodoc>,
+ python3-sphinx-rtd-theme <!nodoc>,
  python3-sphinxcontrib.autoprogram <!nodoc>,
  python3-unicorn,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/python-team/packages/pwntools.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pwntools
 Homepage: https://pwntools.com

=== debian/watch ===
version=4
opts=mode=git,uversionmangle=s/-?(a|b|r?c)/~$1/ \
 https://github.com/Gallopsled/pwntools refs/tags/(\d[\d.]+)

## pwntools 4.14.1

=== docs/requirements.txt ===
--- 
+++ 
@@ -8,7 +8,8 @@
 mako>=1.0.0
 paramiko>=1.15.2
 pip>=6.0.8
-pyelftools>=0.2.3
+pyelftools>=0.29, <0.30; python_version<'3'
+pyelftools>=0.29; python_version>='3'
 pygments>=2.0
 pypandoc
 pyserial>=2.7

=== examples/fmtstr/Makefile ===
CFLAGS := -Wno-unused-result -Wno-format-security
TARGETS := printf.mips printf.mips64 printf.mipsel printf.mips64el printf.arm printf.aarch64 \
	         printf.ppc printf.ppc64 printf.sparc64 printf.native printf.native32 \
	         printf-loop.native printf-loop.native32

.PHONY: run
run: all
	./exploit2.py
	./exploit.py

.PHONY: all
all: $(TARGETS)

.PHONY: clean
clean:
	rm -f $(TARGETS)

# mips variants
%.mips: %.c
	mips-linux-gnu-gcc $(CFLAGS) -static -Os -o "$@" $^
%.mipsel: %.c
	mipsel-linux-gnu-gcc $(CFLAGS) -static -Os -o "$@" $^
%.mips64: %.c
	mips64-linux-gnuabi64-gcc $(CFLAGS) -static -Os -o "$@" $^
%.mips64el: %.c
	mips64el-linux-gnuabi64-gcc $(CFLAGS) -static -Os -o "$@" $^

# arm variants
%.arm: %.c
	arm-linux-gnueabi-gcc $(CFLAGS) -static -Os -o "$@" $^
%.aarch64: %.c
	aarch64-linux-gnu-gcc $(CFLAGS) -static -Os -o "$@" $^

# ppc variants
%.ppc: %.c
	powerpc-linux-gnu-gcc $(CFLAGS) -static -Os -o "$@" $^
%.ppc64: %.c
	powerpc64-linux-gnu-gcc $(CFLAGS) -static -Os -o "$@" $^

# sparc variants
%.sparc64: %.c
	sparc64-linux-gnu-gcc $(CFLAGS) -static -Os -o "$@" $^

# native variants
%.native: %.c
	gcc $(CFLAGS) -o "$@" $^
%.native32: %.c
	gcc $(CFLAGS) -m32 -o "$@" $^

# install deps on ubuntu xenial
.PHONY: install-apt
install-apt:
	apt-get install -y make gcc-mips64el-linux-gnuabi64 gcc-sparc64-linux-gnu gcc-powerpc64-linux-gnu gcc-powerpc-linux-gnu gcc-arm-linux-gnueabi gcc-aarch64-linux-gnu gcc-mips64-linux-gnuabi64 gcc-mipsel-linux-gnu gcc-mips64el-linux-gnuabi64 gcc-mips-linux-gnu gcc-i686-linux-gnu gcc

=== pwnlib/data/syscalls/Makefile ===
--- 
+++ 
@@ -7,4 +7,7 @@
 functions.py:
 	wget https://raw.githubusercontent.com/zachriggle/functions/master/functions.py
 
+generate_darwin:
+	python generate_darwin.py "$(ROOT)"
+
 .phony: all

=== debian/changelog ===
pwntools (4.14.1-1) unstable; urgency=medium

  * New upstream version 4.14.1
  * Bump Standards-Version to 4.7.2
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Apr 2025 10:42:12 +0200

## pwntools 4.15.0

=== docs/Makefile ===
--- 
+++ 
@@ -6,7 +6,6 @@
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
-DASHBUILD     = ./dashbuild.py
 TAR           = tar
 
 # Internal variables.
@@ -145,8 +144,8 @@
 	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."
 
 dash:
-	$(DASHBUILD) source $(BUILDDIR)/dash
-	$(TAR) --exclude='.DS_Store' -cvzf $(BUILDDIR)/dash/pwntools.tgz -C $(BUILDDIR)/dash pwntools.docset
+	$(SPHINXBUILD) -b html -d $(BUILDDIR)/doctrees -t dash source $(BUILDDIR)/html
+	doc2dash $(BUILDDIR)/html -d $(BUILDDIR)/dash -n pwntools -f -I index.html
 	@echo "Build finished. The Dash docset is in $(BUILDDIR)/dash."
 
 changes:

=== extra/docker/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-subdirs=$(shell find . -type d -depth 1 | xargs basename)
+subdirs=$(shell find . -mindepth 1 -maxdepth 1 -type d | xargs -n1 basename)
 tags=base stable beta dev
 ROOT=$(shell git rev-parse --show-toplevel)
 CMD ?= zsh
@@ -7,7 +7,7 @@
 MOUNT_HISTFILE=--mount type=bind,source="$(HISTFILE)",target=/home/pwntools/.history
 endif
 
-all: $(subdirs) $(tags)
+all: $(tags) $(subdirs)
 
 tags: $(tags)

=== travis/docker/Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
 ROOT = $(shell git rev-parse --show-toplevel)
 $(shell reset)
+
+all: doctest3
 
 Dockerfile: FORCE
 	cp $(ROOT)/extra/docker/develop/Dockerfile Dockerfile
@@ -7,7 +9,6 @@
 	cp $(ROOT)/extra/docker/develop/10-import.py 10-import.py
 	cp $(ROOT)/extra/docker/develop/ipython_config.py ipython_config.py
 
-all: doctest3
 
 shell bash: image
 	@echo Running interactive shell
@@ -30,4 +31,4 @@
 	docker build -t travis .
 
 FORCE:
-.PHONY: all image doctest bash
+.PHONY: all image doctest2 doctest3 bash

=== pwnlib/data/syscalls/Makefile ===
--- 
+++ 
@@ -8,6 +8,6 @@
 	wget https://raw.githubusercontent.com/zachriggle/functions/master/functions.py
 
 generate_darwin:
-	python generate_darwin.py "$(ROOT)"
+	python3 generate_darwin.py "$(ROOT)"
 
 .phony: all

=== pwnlib/data/elf/fmtstr/Makefile ===

all: i386

i386: vuln.c
	gcc "$^" -fno-stack-protector -no-pie -m32 -o $@

=== pwnlib/data/elf/ret2dlresolve/Makefile ===

all: i386 amd64

i386: vuln.c
	gcc "$^" -fno-stack-protector -no-pie -m32 -o $@

amd64: vuln.c
	gcc "$^" -fno-stack-protector -no-pie -o $@

=== debian/changelog ===
pwntools (4.15.0-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 4.15.0
  * Refresh patches (no functional changes)
  * Bump copyright years

 -- Timo Röhling <roehling@debian.org>  Wed, 15 Oct 2025 23:17:58 +0200

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,7 @@
  python3-sphinx-rtd-theme <!nodoc>,
  python3-sphinxcontrib.autoprogram <!nodoc>,
  python3-unicorn,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/python-team/packages/pwntools.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pwntools
 Homepage: https://pwntools.com

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = pwntools

%:
	dh $@ --buildsystem=pybuild

# Tests are written as doctests
override_dh_auto_test:

BUILD_DATE = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "@$(SOURCE_DATE_EPOCH)")
execute_after_dh_auto_build:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	PYTHONPATH=$(shell pybuild --print {build_dir} --interpreter python3) \
		$(MAKE) -C docs html SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
endif

=== debian/watch ===
Version: 5

Template: Github
Owner: Gallopsled
Project: pwntools
Dversion-Mangle: auto
Uversion-Mangle: auto
